<?php
/**
 * @file
 * Tests Bynder upload widget.
 *
 * Notice: There is no way to ensure DropzoneJS library is added to the test
 * environment on Drupal.org. We might want to re-enable this test later or keep
 * it here to be able to run it locally.
 */

namespace Drupal\Tests\bynder\FunctionalJavascript;

use Drupal\Core\Field\FieldStorageDefinitionInterface;
use Drupal\Core\Form\FormState;
use Drupal\field\Entity\FieldConfig;
use Drupal\field\Entity\FieldStorageConfig;
use Drupal\FunctionalJavascriptTests\JavascriptTestBase;
use Drupal\Tests\TestFileCreationTrait;

/**
 * Test the Bynder upload widget.
 *
 * @group bynder
 */
class BynderUploadWidgetTest extends JavascriptTestBase {

  use TestFileCreationTrait;

  /**
   * Modules to enable.
   *
   * @var array
   */
  public static $modules = [
    'ctools',
    'entity_browser_bynder_test',
    'bynder',
    'bynder_test_module',
    'node',
    'file',
    'image',
    'system',
    'dblog',
  ];

  /**
   * {@inheritdoc}
   */
  protected function setUp() {
    parent::setUp();

    $this->drupalCreateContentType(['type' => 'media_entity_ct', 'name' => 'Media Type']);

    FieldStorageConfig::create([
      'field_name' => 'field_reference',
      'type' => 'entity_reference',
      'entity_type' => 'node',
      'cardinality' => FieldStorageDefinitionInterface::CARDINALITY_UNLIMITED,
      'settings' => [
        'target_type' => 'media',
      ],
    ])->save();

    FieldConfig::create([
      'field_name' => 'field_reference',
      'entity_type' => 'node',
      'bundle' => 'media_entity_ct',
      'label' => 'Reference',
      'settings' => [
        'handler' => 'default:media',
        'handler_settings' => [
          'target_bundles' => [
            'bynder' => 'bynder',
          ],
        ],
      ],
    ])->save();

    /** @var \Drupal\Core\Entity\Display\EntityFormDisplayInterface $form_display */
    $form_display = $this->container->get('entity_type.manager')
      ->getStorage('entity_form_display')
      ->load('node.media_entity_ct.default');

    $form_display->setComponent('field_reference', [
      'type' => 'entity_browser_entity_reference',
      'settings' => [
        'entity_browser' => 'bynder',
        'open' => TRUE,
      ],
    ])->save();

    $account = $this->drupalCreateUser([
      'administer entity browsers',
    ]);
    $this->drupalLogin($account);
  }

  /**
   * Tests the Bynder upload widget.
   */
  public function testBynderUploadWidget() {
//    $form_state_value = [
//      'triggering_element' => [
//        '#eb_widget_main_submit' => TRUE,
//      ],
//      'values' => [
//        'upload' => [
//          'uploaded_files' => [
//            0 => [
//              'path' => $this->container->get('file_system')->realpath($image_1->uri),
//              'filename' => $image_1->filename,
//            ],
//          ],
//        ],
//      ],
//      'entity_browser' => [
//        'selected_entities' => [],
//      ],
//      'input' => [],
//      'uploaded_entities' => [$media],
//    ];
//    $form_state->setFormState($form_state_value);
//    $element = [
//      'upload' => [
//        'uploaded_files' => [
//          '#parents' => [''],
//        ],
//      ],
//    ];
//    $form = [];
//
//    $no_media = \Drupal::entityTypeManager()->getStorage('media')
//      ->loadByProperties(['field_media_uuid' => '123']);
//    $this->assertEmpty($no_media);
//
//    $widget->submit($element, $form, $form_state);
//
//    $media = \Drupal::entityTypeManager()->getStorage('media')
//      ->loadByProperties(['field_media_uuid' => '123']);
//
//    $this->assertNotEmpty($media);
//
//    $this->drupalGet('admin/structure/media/manage/media_type');
//    $this->getSession()->getPage()->selectFieldOption('type', 'generic');
//    $this->assertSession()->assertWaitOnAjaxRequest();
//    $this->getSession()->getPage()->pressButton('Save media bundle');
//
//    $form_state_value['triggering_element']['#bynder_upload_submit'] = TRUE;
//    $form_state->setFormState($form_state_value);
//
//    $widget->submit($element, $form, $form_state);
//
//    $this->drupalGet('admin/reports/dblog');
//    $this->assertSession()->responseContains('Media bundle Media type is not using Bynder plugin. Please fix the Bynder search widget configuration.');
//
//    $this->drupalGet('admin/reports/dblog/confirm');
//    $this->getSession()->getPage()->pressButton('Confirm');
//    $this->assertSession()->responseNotContains('Media bundle Media type is not using Bynder plugin. Please fix the Bynder search widget configuration.');
//
//    current($media)->delete();
//    $this->drupalGet('admin/structure/media/manage/media_type');
//    $this->getSession()->getPage()->clickLink('Delete');
//    $this->getSession()->getPage()->pressButton('Delete');
//
//    $widget->submit($element, $form, $form_state);
//    $this->drupalGet('admin/reports/dblog');
//    $this->assertSession()->responseContains('Media bundle media_type does not exists. Please fix the Bynder search widget configuration.');
  }

}
